function BodyLadderMP:StartActivity()
	print("START! -- BodyLadderMP:StartActivity()!");
	zspawn = {Timer(),Timer(),Timer(),Timer()};
	interruptTimer = {Timer(), Timer(), Timer(),Timer()};
	timer = 0;
	self.gameover = 0;
	playersdead = 0;
	pl = {};
	height = {};
	ztime = {};
	zside = {};
	interrupt = {};
	spawnedZombies = {};
	checkpoint = {};
	lives = {}; 
	kills = {};
	rtime = {};
	rtimer = {};
	isdead = {};
	aliveZombies = {};
	playerlost = {};
	--Barrier size
	brs = 20;
	--Playable area size
	ars = 320;
	--Zombie spawn distance from wall
	zsdfw = 10;
	player1 = {};
	player2 = {};
	player3 = {};
	player4 = {};
	playerName = {player1,player2,player3,player4};
	ActivityMan:GetActivity():SetTeamFunds(0,0);
	for pla = 1, self.PlayerCount do
		print("This is player:" ..pla);
		player = pla-1;
		ztime[pla] = 3000;
		height[pla] = 0;
		zside[pla] = 0;
		spawnedZombies[pla] = 0;
		checkpoint[pla] = 0;
		interrupt[pla] = 0;
		lives[pla] = 5;
		kills[pla] = 0;
		rtime[pla] = 500;
		rtimer[pla] = 0;
		isdead[pla] = 0;
		aliveZombies[pla] = 0;
		playerlost[pla] = 0;
		playerName[pla].playerBrain = CreateActor("Invisi Brain")
		x = ((ars+(brs*2))*pla)-((ars+(brs*2))/2);
		playerName[pla].playerBrain.Pos = Vector(x,(2300));
		playerName[pla].playerBrain.Team = 0;
		MovableMan:AddActor(playerName[pla].playerBrain);
		playerName[pla].playerActor = respawn(pla);
		self:SetPlayerBrain(playerName[pla].playerBrain, player);
		self:SetLandingZone(playerName[pla].playerBrain.Pos, player);
		self:SwitchToActor(playerName[pla].playerActor, player, self:GetTeamOfPlayer(player));
	end
	AudioMan:ClearMusicQueue();
	AudioMan:PlayMusic("Body Ladder MultiPlayer.rte/Naturally_Industrial.ogg", -1, -1);
end

function respawn(pla)
	pl[pla] = CreateAHuman("Survivor");
	pl[pla].AIMode = Actor.AIMODE_SENTRY;
	pl[pla].Team = 0;
	pl[pla]:AddInventoryItem(CreateHDFirearm("Baseball Bat"));
	if checkpoint[pla] > 0 then
		pl[pla]:AddInventoryItem(CreateHDFirearm("Pistol"));
	end
	if checkpoint[pla] > 1 then
		pl[pla]:AddInventoryItem(CreateHDFirearm("Auto Pistol"));
	end
	if checkpoint[pla] > 2 then
		pl[pla]:AddInventoryItem(CreateHDFirearm("Shotgun"));
	end
	if checkpoint[pla] > 3 then
		pl[pla]:AddInventoryItem(CreateHDFirearm("Assault Rifle"));
	end
	if checkpoint[pla] > 4 then
		pl[pla]:AddInventoryItem(CreateHDFirearm("Auto Shotgun"))
	end
	if checkpoint[pla] > 5 then
		pl[pla]:AddInventoryItem(CreateHDFirearm("Heavy Auto Shotgun"));
	end
	if checkpoint[pla] > 6 then
		pl[pla]:AddInventoryItem(CreateHDFirearm("Gatling Gun"));
	end
	pl[pla].Pos = Vector(((ars+(brs*2))*pla)-((ars+(brs*2))/2),-height[pla]+2435);
	MovableMan:AddActor(pl[pla]);
	return pl[pla];
end

function BodyLadderMP:PauseActivity(pause)
	print("PAUSE! -- BodyLadderMP:PauseActivity()!");
end

function BodyLadderMP:UpdateActivity()
	if timer >= 20 and self.gameover == 0 then
		for pla = 1, self.PlayerCount do
			player = pla-1;
			if MovableMan:IsActor(playerName[pla].playerActor) then
				if math.ceil(-playerName[pla].playerActor.Pos.Y + 2441) > height[pla] then
					height[pla] = math.ceil(-playerName[pla].playerActor.Pos.Y + 2441);
				end
				if -zspawn[pla]:LeftTillSimMS(0) > ztime[pla] then
					local zlist = {"Zombie Thin", "Zombie Medium", "Zombie Fat"}
					local zombie = CreateAHuman(zlist[math.random(#zlist)], "Body Ladder MultiPlayer.rte");
					if zside[pla] == 0 then
						zombie:AddAISceneWaypoint(Vector(((ars+(brs*2))*pla)-brs,playerName[pla].playerActor.Pos.Y));
						zombie.Pos = Vector(((ars+(brs*2))*pla)-brs-ars+zsdfw,playerName[pla].playerActor.Pos.Y);
						zside[pla] = 1;
					else
						zombie:AddAISceneWaypoint(Vector(((ars+(brs*2))*pla)-brs-ars,playerName[pla].playerActor.Pos.Y));
						zombie.Pos = Vector(((ars+(brs*2))*pla)-brs-zsdfw,playerName[pla].playerActor.Pos.Y);
						zside[pla] = 0;
					end
					zombie.Team = -1;
					zombie.AIMode = Actor.AIMODE_GOTO;
					MovableMan:AddActor(zombie);
					spawnedZombies[pla] = spawnedZombies[pla] + 1;
					zspawn[pla]:Reset();
				end
				if MovableMan:IsActor(playerName[pla].playerActor) and isdead[pla] == 0 then
					local team = self:GetTeamOfPlayer(player);
					if self:GetControlledActor(player) == nil then
						self:SwitchToActor(playerName[pla].playerActor, player, team);
					else
						local pid = self:GetControlledActor(player).ID;
						if playerName[pla].playerActor.ID ~= pid then
							self:SwitchToActor(playerName[pla].playerActor, player, team);
						end
					end
				end
				
				if height[pla] > 100 and checkpoint[pla] < 1 then
					interrupt[pla] = 5000;
					interruptTimer[pla]:Reset();
					self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Height of 100 reached!  New weapon: Pistol.  Zombie spawn speed increased!", player, 0, 5000, false);
					playerName[pla].playerActor:AddInventoryItem(CreateHDFirearm("Pistol"));
					ztime[pla] = 2750;
					checkpoint[pla] = 1;
				end

				if height[pla] > 200 and checkpoint[pla] < 2  then
					interrupt[pla] = 5000;
					interruptTimer[pla]:Reset();
					self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Height of 200 reached!  New weapon: Auto Pistol.  Zombie spawn speed increased!", player, 0, 5000, false);
					playerName[pla].playerActor:AddInventoryItem(CreateHDFirearm("Auto Pistol"));
					ztime[pla] = 2500;
					checkpoint[pla] = 2;
				end

				if height[pla] > 300 and checkpoint[pla] < 3  then
					interrupt[pla] = 5000;
					interruptTimer[pla]:Reset();
					self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Height of 300 reached!  New weapon: Shotgun.  Zombie spawn speed increased!", player, 0, 5000, false);
					playerName[pla].playerActor:AddInventoryItem(CreateHDFirearm("Shotgun"));
					ztime[pla] = 2250;
					checkpoint[pla] = 3;
				end
				
				if height[pla] > 400 and checkpoint[pla] < 4  then
					interrupt[pla] = 5000;
					interruptTimer[pla]:Reset();
					self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Height of 400 reached!  New weapon: Assault Rifle.  Zombie spawn speed increased!", player, 0, 5000, false);
					playerName[pla].playerActor:AddInventoryItem(CreateHDFirearm("Assault Rifle"));
					ztime[pla] = 2000;
					checkpoint[pla] = 4;
				end

				if height[pla] > 500 and checkpoint[pla] < 5  then
					interrupt[pla] = 5000;
					interruptTimer[pla]:Reset();
					self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Height of 500 reached!  New weapon: Auto Shotgun.  Zombie spawn speed increased!", player, 0, 5000, false);
					playerName[pla].playerActor:AddInventoryItem(CreateHDFirearm("Auto Shotgun"));
					ztime[pla] = 1750;
					checkpoint[pla] = 5;
				end

				if height[pla] > 600 and checkpoint[pla] < 6  then
					interrupt[pla] = 5000;
					interruptTimer[pla]:Reset();
					self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Height of 600 reached!  New weapon: Heavy Auto Shotgun.  Zombie spawn speed increased!", player, 0, 5000, false);
					playerName[pla].playerActor:AddInventoryItem(CreateHDFirearm("Heavy Auto Shotgun"));
					ztime[pla] = 1000;
					checkpoint[pla] = 6;
				end

				if height[pla] > 700 and checkpoint[pla] < 7 then
					interrupt[pla] = 5000;
					interruptTimer[pla]:Reset();
					self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Height of 700 reached!  New weapon: Gatling Gun.  You're almost there!", player, 0, 5000, false);
					playerName[pla].playerActor:AddInventoryItem(CreateHDFirearm("Gatling Gun"));
					ztime[pla] = 500;
					checkpoint[pla] = 7;
				end

				if height[pla] > 750 and MovableMan:IsActor(playerName[pla].playerActor) and self.gameover == 0 then
					self.WinnerTeam = Activity.TEAM_1;
					for pla2 = 1, self.PlayerCount do
						if pla2 ~= pla then
							playerlost[pla2] = 1;
						end
					end
					ActivityMan:EndActivity();
				end
			end
			if interruptTimer[pla]:LeftTillSimMS(interrupt[pla]) <= 0 then
				FrameMan:SetScreenText("Height: " .. height[pla].. "\nLives left:" ..lives[pla].. "\nKills: " ..kills[pla], player, 0, 1, false);
			end
			for actor in MovableMan.Actors do
				if (actor.Pos.X < ((ars+(brs*2))*pla)-(ars+(brs)) and actor.Pos.X > ((ars+(brs*2))*pla)-(ars+(brs*2))) then
					actor.Vel.X = 2;
				end
				if (actor.Pos.X > ((ars+(brs*2))*pla)-brs and actor.Pos.X < ((ars+(brs*2))*pla)) then
					actor.Vel.X = -2;
				end
				if actor.Team == -1 and (actor.Pos.X < ((ars+(brs*2))*pla) and actor.Pos.X > ((ars+(brs*2))*pla)-(ars+(brs*2))) then
					aliveZombies[pla] = aliveZombies[pla] + 1;
				end
			end
			kills[pla] = spawnedZombies[pla] - aliveZombies[pla];
			aliveZombies[pla] = 0;
			for object in MovableMan.Particles do
				if (object.Pos.X < ((ars+(brs*2))*pla)-(ars+(brs)) and object.Pos.X > ((ars+(brs*2))*pla)-(ars+(brs*2))) then
					object.Vel.X = 2;
				end
				if (object.Pos.X > ((ars+(brs*2))*pla)-brs and object.Pos.X < ((ars+(brs*2))*pla)) then
					object.Vel.X = -2;
				end
			end
			for item in MovableMan.Items do
				if (item.Pos.X < ((ars+(brs*2))*pla)-(ars+(brs)) and item.Pos.X > ((ars+(brs*2))*pla)-(ars+(brs*2))) then
					item.Vel.X = 2;
				end
				if (item.Pos.X > ((ars+(brs*2))*pla)-brs and item.Pos.X < ((ars+(brs*2))*pla)) then
					item.Vel.X = -2;
				end
			end
			if ((not MovableMan:IsActor(playerName[pla].playerActor))) then
				playerName[pla].playerActor = nil
				if isdead[pla] == 0 then
					isdead[pla] = 1;
					lives[pla] = lives[pla] - 1;
					self:SwitchToActor(playerName[pla].playerBrain, player, self:GetTeamOfPlayer(player));
				end
			end
			if isdead[pla] == 1 then
				rtimer[pla] = (rtimer[pla] + 1);
				if rtimer[pla] >= rtime[pla] and lives[pla] > 0 then
					playerName[pla].playerActor = respawn(pla);
					rtimer[pla] = 0;
					isdead[pla] = 0;
				end
			end
			if lives[pla] <= 0 and self.gameover == 0 and playerlost[pla] == 0 then
				playersdead = playersdead + 1;
				playerlost[pla] = 1;
			end
			if playersdead >= self.PlayerCount - 1 and self.gameover == 0 then
				self.WinnerTeam = Activity.TEAM_1;
				ActivityMan:EndActivity();
			end	
		end	 
	elseif self.gameover == 0 then
		timer = timer + 1;
	end 
end

function BodyLadderMP:EndActivity()
	print("END! -- BodyLadderMP:EndActivity()!");
	for pla = 1, self.PlayerCount do
		player = pla-1;
		self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
		if playerlost[pla] == 1 then
			FrameMan:SetScreenText("You Lost\nYour max reached height was at " ..height[pla].. " pixels\nYou had " ..lives[pla].." lives left\nYou killed " ..kills[pla].. " Zombies", player, 0, 20000, false);
		elseif playerlost[pla] == 0 then
			FrameMan:SetScreenText("You Won!\nYour max reached height was at " ..height[pla].. " pixels\nYou had " ..lives[pla].." lives left\nYou killed " ..kills[pla].. " Zombies", player, 0, 20000, false);
		end
	end
	self.gameover = 1;
end 